/*
    libvice - SGI O2 Video Image Compression Engine Library
    Copyright (C) 2002 Vivien Chappelier
                       Ilya Volynets

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

#include "vice.h"

volatile vice_dma_desc *vice_dma_get_desc(vice_t *vice, int chnum, int dnum)
{
    int dn = dnum + (chnum << 2);
    return vice->regs + VICE_DMA_DESC(dn);
}

int vice_dma_start(vice_t *vice, dma_run *run)
{
    if(ioctl(vice->fd, VICE_IOCTL_DO_DMA, run) == -1) {
	fprintf(stderr, "error starting DMA: %s\n", strerror(errno));
	return 0;
    }
    return 1;
}
