#include <asm/asm.h>
#include <asm/regdef.h>
#include <linux/vice.h>
        
#define zero	$0	/* wired zero */
#define AT	$at	/* assembler temp - uppercase because of ".set at" */
#define r0	$2	/* return value - caller saved */
#define r1 	$3
#define a0	$4	/* argument registers */
#define a1	$5
#define a2	$6
#define a3	$7
#define a4	$8	/* arg reg 64 bit; caller saved in 32 bit */
#define ta0	$8
#define a5	$9
#define ta1	$9
#define a6	$10
#define ta2	$10
#define a7	$11
#define ta3	$11
#define t0	$12	/* caller saved */
#define t1	$13
#define t2	$14
#define t3	$15
#define s0	$16	/* callee saved */
#define s1	$17
#define s2	$18
#define s3	$19
#define s4	$20
#define s5	$21
#define s6	$22
#define s7	$23
#define t8	$24	/* caller saved */
#define t9	$25	/* callee address for PIC/temp */
#define jp	$25	/* PIC jump register */
#define k0	$26	/* kernel temporary */
#define k1	$27
#define gp	$28	/* global pointer - caller saved for PIC */
#define sp	$29	/* stack pointer */
#define fp	$30	/* frame pointer */
#define s8	$30	/* callee saved */
#define ra	$31	/* return address */
#define v0 $v0
#define v1 $v1
#define v2 $v2
#define v3 $v3
#define v4 $v4
#define v5 $v5
#define v6 $v6
#define v7 $v7
#define v8 $v8
#define v9 $v9
#define v10 $v10
#define v11 $v11
#define v12 $v12
#define v13 $v13
#define v14 $v14
#define v15 $v15
#define v16 $v16
#define v17 $v17
#define v18 $v18
#define v19 $v19
#define v20 $v20
#define v21 $v21
#define v22 $v22
#define v23 $v23
#define v24 $v24
#define v25 $v25
#define v26 $v26
#define v27 $v27
#define v28 $v28
#define v29 $v29
#define v30 $v30
#define v31 $v31
        
#define MSP_DMA_CH1_CTL $16 /* ctc1 */
#define MSP_DMA_CH1_STAT $17 /* cfc1 */
#define MSP_DMA_CH1_DATA $18 /*ctc1*/
#define MSP_SOFT_INT $23
        
#define MSP_DMA_CH1_D1_CTL $0 /* mtc3 */
#define MSP_DMA_CH1_D1_SMEM_HI $1
#define MSP_DMA_CH1_D1_SMEM_LO $2
#define MSP_DMA_CH1_D1_WIDTH $3
#define MSP_DMA_CH1_D1_STRIDE $4
#define MSP_DMA_CH1_D1_LINES $5
#define MSP_DMA_CH1_D1_VMEM_Y $6
#define MSP_DMA_CH1_D1_VMEM_C $7

#define MSP_SYSCALL_EXIT 1
                
.macro	SYSCALL number
        li	$at, \number
        ctc1    $at, MSP_SOFT_INT # soft int
.endm

.macro DMA_START flags smem vmemy vmemc stride width height
        mtc3 \flags, MSP_DMA_CH1_D1_CTL
        move $at, \smem
        srl  $at, 16
        mtc3 $at, MSP_DMA_CH1_D1_SMEM_HI
        move $at, \smem
        andi  $at, 0xffff
        mtc3 $at, MSP_DMA_CH1_D1_SMEM_LO
        mtc3 \stride, MSP_DMA_CH1_D1_STRIDE
        mtc3 \width, MSP_DMA_CH1_D1_WIDTH
        mtc3 \height, MSP_DMA_CH1_D1_LINES
        mtc3 \vmemy, MSP_DMA_CH1_D1_VMEM_Y
        mtc3 \vmemc, MSP_DMA_CH1_D1_VMEM_C
        li $at, VICE_DMA_CTL_DESC1 | VICE_DMA_CTL_GO
        ctc1 $at, MSP_DMA_CH1_CTL
.endm

.macro DMA_WAIT
    cfc1 $at, MSP_DMA_CH1_STAT
1: # wait for DMA completion
    andi $at, VICE_DMA_STAT_DONE
    beqz $at, 1b
    cfc1 $at, MSP_DMA_CH1_STAT
.endm

.set mips1
.set noat
.set noreorder
.text
msp_code_start:

    li a0, 0x8080
    mtc2 a0, v31[0]
    mtc2 a0, v31[2]
    mtc2 a0, v31[4]
    mtc2 a0, v31[6]
    mtc2 a0, v31[8]
    mtc2 a0, v31[10]
    mtc2 a0, v31[12]
    mtc2 a0, v31[14]

    li a0, 0x1234
    ctc1 a0, MSP_DMA_CH1_DATA
        
# 352 x 288
    
    li s3, 0        # system memory pointer
    li s0, 0x8000   # vice memory pointer
    li s4, 352      # pitch
    li s2, 240 >> 4 # y counter
    li t2, 0
.io_buf_loop_y:
    li s1, 352 >> 4 # x counter
    li t1, 0
.io_buf_loop_x:        

    # load macroblock in vice memory

#    li a0, (VICE_DMA_FILL|VICE_DMA_TOVICE|VICE_DMA_HALT)
    li a0, (VICE_DMA_TOVICE|VICE_DMA_HALT)  # DMA operation
    move a1, s3                             # system memory pointer
    li a2, VICE_DRAM_A                      # vice memory pointer for Y
    li a3, 0                                # vice memory pointer for C
    move a4, s4                             # stride
    li a5, 16                               # width
    li a6, 16                               # height
    DMA_START a0 a1 a2 a3 a4 a5 a6

    DMA_WAIT

        
    # play with macroblock
    lqv v0, 0(s0)
    lqv v1, 1(s0)
    lqv v2, 2(s0)
    lqv v3, 3(s0)
    lqv v4, 4(s0)
    lqv v5, 5(s0)
    lqv v6, 6(s0)
    lqv v7, 7(s0)
    lqv v8, 8(s0)
    lqv v9, 9(s0)
    lqv v10, 10(s0)
    lqv v11, 11(s0)
    lqv v12, 12(s0)
    lqv v13, 13(s0)
    lqv v14, 14(s0)
    lqv v15, 15(s0)
    lqv v16, 16(s0)
     
    vsubb v0, v0, v1
    vaccb v0, v0, v31, 1
    vsubb v1, v1, v2
    vaccb v1, v1, v31, 1        
    vsubb v2, v2, v3
    vaccb v2, v2, v31, 1            
    vsubb v3, v3, v4
    vaccb v3, v3, v31, 1            
    vsubb v4, v4, v5
    vaccb v4, v4, v31, 1            
    vsubb v5, v5, v6
    vaccb v5, v5, v31, 1            
    vsubb v6, v6, v7
    vaccb v6, v6, v31, 1            
    vsubb v7, v7, v8
    vaccb v7, v7, v31, 1            
    vsubb v8, v8, v9
    vaccb v8, v8, v31, 1            
    vsubb v9, v9, v10
    vaccb v9, v9, v31, 1            
    vsubb v10, v10, v11
    vaccb v10, v10, v31, 1            
    vsubb v11, v11, v12
    vaccb v11, v11, v31, 1            
    vsubb v12, v12, v13
    vaccb v12, v12, v31, 1            
    vsubb v13, v13, v14
    vaccb v13, v13, v31, 1
    vsubb v14, v14, v15
    vaccb v14, v14, v31, 1            
                                
    sqv v0, 0(s0)
    sqv v1, 1(s0)
    sqv v2, 2(s0)
    sqv v3, 3(s0)
    sqv v4, 4(s0)
    sqv v5, 5(s0)
    sqv v6, 6(s0)
    sqv v7, 7(s0)
    sqv v8, 8(s0)
    sqv v9, 9(s0)
    sqv v10, 10(s0)
    sqv v11, 11(s0)
    sqv v12, 12(s0)
    sqv v13, 13(s0)
    sqv v14, 14(s0)
    sqv v15, 15(s0)
    sqv v16, 16(s0)
    sqv v17, 17(s0)
    sqv v18, 18(s0)
    sqv v19, 19(s0)
    sqv v20, 20(s0)
    sqv v21, 21(s0)
    sqv v22, 22(s0)
    sqv v23, 23(s0)
    sqv v24, 24(s0)
    sqv v25, 25(s0)
    sqv v26, 26(s0)
    sqv v27, 27(s0)
    sqv v28, 28(s0)
    sqv v29, 29(s0)
    sqv v30, 30(s0)
    sqv v31, 31(s0)                        

    # store macroblock in system memory
    li a0, (VICE_DMA_FROMVICE|VICE_DMA_HALT)  # DMA operation
    move a1, s3                               # system memory pointer
    li a2, VICE_DRAM_A                        # vice memory pointer for Y
    li a3, 0                                  # vice memory pointer for C
    move a4, s4                               # stride
    li a5, 16                                 # width
    li a6, 16                                 # height
    DMA_START a0 a1 a2 a3 a4 a5 a6

    DMA_WAIT

    # update pointers and counters
    addi s3, 16 # system_pointer += 16
    addi t1, 1  # x++
    bne t1, s1, .io_buf_loop_x
        nop

    # end of line
    sub s3, s3, s4   # system_pointer -= pitch
    move t0, s4      # t0 = pitch
    sll t0, 4        # t0 = pitch * 16
    add s3, s3, t0   # system_pointer += pitch * 16
    addi t2, 1       # y++
    bne t2, s2, .io_buf_loop_y
        nop
        
    SYSCALL MSP_SYSCALL_EXIT
    break 1

msp_code_end:
    .global msp_code_start
    .global msp_code_end
                
